/// Handles all events from SDL_PollEvent.
module mde.events;

import mde.scheduler;

import mde.input.input;

import derelict.sdl.events;

import tango.util.log.Log : Log, Logger;

private Logger logger;
static this() {
    logger = Log.getLogger ("mde.events");
}

static bool run = true;

void addEventsSchedule () {
    Scheduler.perFrame (&pollEvents);
}

void pollEvents (double) {
    SDL_Event event;
    while (SDL_PollEvent (&event)) {
        switch (event.type) {
            case SDL_QUIT:
                logger.info ("Quit requested");
                run = false;
                break;
            default:
                input (event);
        }
    }
}
